(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/PPSymbol.sml,v
   Comment: Pretty printer for Symbols
   Release: scope-0-16_final

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  NOTES:

  I did not like the idea of embedding pretty printers into respective
  modules because I am afraid about portability. It seems that the same
  library is both in MoscowML and SMLNJ but still it is not in Basis Library.

  The module is kept separately so if I needed to port the thing I can simply
  omit this module - it is only used in interactive sessions and occasionally
  for debug prints.

  At the moment the module is loaded in use.sml, but I might link it into
  executable at certain point - if there is a need for this kind of
  debugging.

  PPSymbol.sml,v 1.4 2003/07/08 15:45:01 wasowski Exp
*)

load "PP";

local 

  open PP;

  (* pretty printer for symbols *)
  
  fun ppsymbol pps ( d : Symbol.symbol ) = 
	let val _ = begin_block pps INCONSISTENT 6
	    val _ = add_string  pps ( "(" ^ Int.toString(Symbol.toInt d) 
				      ^ ":" ^ Symbol.name d ^ ")" ); 
	in
	   end_block pps
	end

in
  val _ = installPP ppsymbol;
  val _ = print "Pretty printer for Symbol.symbol installed.\n";
end

