(* perhaps we also need the full set calculus on inputs *)

structure envsetabs = struct

open Symbol

datatype binop = OpAnd | OpImp | OpEquiv | OpOr | OpXor | OpNeq 

datatype unop  = OpNot | OpCompl

datatype typ   = Input | Output (* input a,b,c,d; *)

datatype binding = Bind of symbol * symbol list * exp 

(* only bind to complete observers and generators.
   only parameterize with generators and observers *)
(* no formulae or sets as parameters at the moment *)

and exp = CstB of bool
	| Var of symbol
        | Let of binding list * exp
        | Prim1 of unop * exp
        | Prim2 of binop * exp * exp
 	| App of symbol * exp list
	| Set of symbol list
	| Sum of exp list
        | Dot of exp * exp

datatype toplevel = Binding of binding

type spec = toplevel list

end