#!/usr/bin/perl -w 
#
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/compilesmoke.pl,v
# Comment: A shortcut for code genereting and compiling a model in smoke(debug) mode 
# Release: scope-0-16_final
#
#    Copyright (C) 2002 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Usage:
#
# compilesmoke path_to_model [codgen [output_dir [preopts]]]
#
# defualt output dir is test/sandbox/.
#
# WAWRNING: no error control
#
# compilesmoke.pl,v 1.7 2003/07/26 20:59:11 wasowski Exp
# 

use File::Basename;
use test::src::ScopeTest;

if (! $ARGV[0]) { 
	print "\ncompile.pl  path_to_model [codgen [output_dir [preopts]]]\n\n"; 
	exit;
}

$file=$ARGV[0];
$fbase = fileparse($file,qr/\.[^.]*/);

if ($ARGV[1]) { $codgen=$ARGV[1]; }
else { $codgen = "C1"; }

if ($ARGV[2]) { $outdir = $ARGV[2]."/"; }
else { $outdir = "test/sandbox/"; }

if ($ARGV[3]) { $preopts = $ARGV[3]; }
else { $preopts = ""; }

if ( (system "rm -Rf $outdir/*") == 0
	&& (system "$ScopeTest::scope $preopts --queuelen=20 --outdir=$outdir --debug --smoke -c$codgen $file -cCstubs -cCdrv") == 0
	&& (system ("cc -pedantic -g -I $ScopeTest::scopedir -I $outdir/ --ansi $outdir/*.c -o $outdir/$fbase")) == 0
        && (system "strip $outdir/$fbase") == 0 )
     { exit 0; } 
else { exit 1; }


