(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tInterprCases.sml,v
   Comment: Cases for interpreter test.    
   Release: scope-0-16_final

     Copyright (C) 2001-2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTES:

   Specification language is defined in tInterprLang.sml This file is a
   script designed to be used from tInterpr.sml

	PROBLEMS:

	1. Logic of expressions and variables is hardly tested

	2. (CRITICAL) conflict resolution is not tested

   tInterprCases.sml,v 1.30 2003/08/06 11:27:01 wasowski Exp
*)
  
		    
  val testcases =

	"test/run/actions01.vsp" INITIAL (["topstate.*.first"],[]) || END

		STEPS	 IF "event" [] THEN 
				STATE ["topstate.*.second"]
				OUT   [!!"action" []] || END
		CONTINUE 
			
			IF "event"  [] THEN STATE NO_CHANGE OUT [] || END 

		CONTINUE END
	
	NEXT "test/run/actions02.vsp" INITIAL (["top.*.first"],[]) || END

		STEPS    IF "event" [] THEN
				STATE ["top.*.second"]
				OUT   [!!"lookup_extvar" [ValI 0],
				       !!"lookup_extvar" [ValI 0],
				       !!"lookup_extvar" [ValI 0],
				       !!"lookup_extvar" [ValI 0]] || END
		CONTINUE IF "event" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "event" [] THEN STATE NO_CHANGE OUT [] || END

		CONTINUE END

	NEXT "test/run/actions03.vsp" INITIAL (["topstate.*.Q1.Q11.P1", 
					  "topstate.*.Q1.Q12.P3"],[]) || END

		STEPS	 IF "e2" [] THEN
				STATE ["topstate.*.Q1.Q11.P2.*.A1",
				       "topstate.*.Q1.Q12.P4"] 
				OUT   [] || END
		CONTINUE IF "e2" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "e1" [] THEN 
				STATE ["topstate.*.Q1.Q11.P2.*.A2",
				       "topstate.*.Q1.Q12.P4"]
				OUT   [] || END
		CONTINUE IF "e1" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "e2" [] THEN STATE NO_CHANGE OUT [] || END
		
		CONTINUE END
	
(*	NEXT "test/run/actions04.vsp" INITIAL (["topstate.*.first"],[]) || END

		STEPS    IF "Event" [] THEN 
				STATE NO_CHANGE (* conflict -> broken model *)
				OUT   [] || END
		
		CONTINUE END *)
	
	NEXT "test/run/trans01.vsp" INITIAL (["topstate.*.first"],[]) || END
		
		STEPS    IF "Event" [] THEN 
				STATE NO_CHANGE 
				OUT [!!"action" []] || END
		CONTINUE IF "Event" [] THEN 
				STATE NO_CHANGE 
				OUT [!!"action" []] || END
		CONTINUE IF "Event" [] THEN 
				STATE NO_CHANGE 
				OUT [!!"action" []] || END
		CONTINUE END

	NEXT "test/run/trans03.vsp" INITIAL (["topstate.*.first.*.second"],
					[!!"action1" [], !!"action2" []]) || END

		STEPS	 IF "Event" [] THEN 
				STATE NO_CHANGE
				OUT [!!"action3" [],
				     !!"action4" [],
				     !!"action5" [],
				     !!"action1" [],
				     !!"action2" []] || END
		CONTINUE END 

	NEXT "test/run/trans05.vsp" INITIAL (["topstate.*.I.E.L.A.C", 
					 "topstate.*.I.E.L.B.J", 
					 "topstate.*.I.F.R"],
					[!!"I_ENTER" [],
					 !!"R_ENTER" [],
					 !!"L_ENTER" [],
					 !!"J_ENTER" [],
					 !!"C_ENTER" []])|| END

		STEPS	IF "Event1" [] THEN
				STATE ["topstate.*.I.E.L.A.D",
				       "topstate.*.I.E.L.B.J",
				       "topstate.*.I.F.Q.*.H"]
				OUT   [!!"C_EXIT" [],
				       !!"R_EXIT" [],
				       !!"action" [],
				       !!"D_ENTER" [],
				       !!"Q_ENTER" [],
				       !!"H_ENTER" []] || END
		
		CONTINUE END 

	NEXT "test/run/trans06.vsp" INITIAL (["topstate.*.O.P.Q",
					 "topstate.*.O.N.E.L.A",
					 "topstate.*.O.N.E.K.C"],
					[!! "I_ENTER" []]) || END
					
	(* this test is ILLEGAL. Visual STATE would not run this model
	   properly at all. It exhibits a certain generality of our semantics
	   - if we relax condition that targets may be ancestrally related. 
	   This might be not maintained by code generators. Relaxing the
	   condition influences (static) scope computation as adding an extra
	   target might force higher scope (in our semantics. strictly spekain
	   in VS it should be always redundant as force state actions have no
	   loop semantics in VS). *)
	   
		STEPS    IF "Event1" [] THEN
				STATE ["topstate.*.O.P.Q",
				       "topstate.*.O.N.E.L.B",
				       "topstate.*.O.N.E.K.D"] 
				OUT   [] || END
		CONTINUE IF "Event1" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event2" [] THEN	
				STATE ["topstate.*.O.P.Q",
				       "topstate.*.O.N.E.L.A",
				       "topstate.*.O.N.E.K.D"]
				OUT   [] || END
		CONTINUE IF "Event2" [] THEN STATE NO_CHANGE OUT [] || END

		RESTART  IF "Event2" [] THEN
				STATE ["topstate.*.O.P.Q",
				       "topstate.*.O.N.E.L.A",
				       "topstate.*.O.N.E.K.D"]
				OUT   [] || END
		CONTINUE IF "Event2" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event1" [] THEN
				STATE ["topstate.*.O.P.Q",
				       "topstate.*.O.N.E.L.B",
				       "topstate.*.O.N.E.K.D"] 
				OUT   [] || END
		CONTINUE IF "Event1" [] THEN STATE NO_CHANGE OUT [] || END
		
		CONTINUE END
	
	NEXT "test/run/trans07.vsp"
		INITIAL (["topstate.*.first.*.second.*.third"],
			 [!! "action5" [],
			  !! "action6" [],
			  !! "action7" []]) || END
		STEPS IF "Event" [] THEN
				STATE NO_CHANGE
				OUT [!!"action1" [],
				     !!"action2" [],
				     !!"action3" [],
				     !!"action4" [],
				     !!"action5" [],
				     !!"action6" [],
				     !!"action7" []] || END
		CONTINUE END

	NEXT "test/run/trans08.vsp"
		INITIAL (["topstate.*.first.R1.second.R3.A",
			  "topstate.*.first.R1.second.R4.B",
			  "topstate.*.first.R2.third"],
			 [!! "action5" [],
			  !! "action7" [],
			  !! "action6" [],
			  !! "action10" [],
			  !! "action8" []]) || END
		STEPS IF "Event" [] THEN
				STATE NO_CHANGE
				OUT [!!"action1"  [],
				     !!"action11" [],
				     !!"action9"  [],
				     !!"action2"  [],
				     !!"action3"  [],
				     !!"action4"  [],
				     !!"action5"  [],
				     !!"action7"  [],
				     !!"action6"  [],
				     !!"action10" [],
				     !!"action8"  []] || END
		CONTINUE END

	NEXT "test/run/trans09.vsp" 
		(* this test actually does not confrom to VS behaviour *)
		INITIAL (["topstate.*.first.R1.second.*.A",
			  "topstate.*.first.R2.third.*.B"],
			 [!!"action5" [],
			  !!"action1" [],
			  !!"action10" [],
			  !!"action6" [],
			  !!"action8" []]) || END
		STEPS IF "E1" [] THEN
				STATE NO_CHANGE
				OUT [!!"action9"  [],
				     !!"action2"  [],
				     !!"action11" [],
				     !!"action4"  [],
				     !!"action6"  [],
				     !!"action8"  [],
				     !!"action10" []] || END
		CONTINUE IF "E2" [] THEN
				STATE NO_CHANGE
				OUT [!!"action11" [],
				     !!"action7"  [],
				     !!"action1"  [],
				     !!"action10" [],
				     !!"action9"  [],
				     !!"action2"  [],
				     !!"action4"  [],
				     !!"action6"  [],
				     !!"action8"  [] ] || END

		CONTINUE END	

	NEXT "test/run/trans11.vsp"

		INITIAL (["topstate.*.I.E.L.A.C","topstate.*.I.E.L.B.J",
			  "topstate.*.I.F.R"],
			 [!!"I_ENTER" [],
			  !!"R_ENTER" [],
			  !!"L_ENTER" [],
			  !!"J_ENTER" [],
			  !!"C_ENTER" []]) || END

		STEPS IF "Event2" [] THEN
			STATE ["topstate.*.I.E.L.A.D","topstate.*.I.E.L.B.J",
			       "topstate.*.I.F.Q.*.H"]
			OUT [!!"R_EXIT" [],
			     !!"J_EXIT" [],
			     !!"C_EXIT" [],
			     !!"L_EXIT" [],
			     !!"I_EXIT" [],
			     !!"action" [],
			     !!"I_ENTER" [],
			     !!"Q_ENTER" [],
			     !!"H_ENTER" [],
			     !!"L_ENTER" [],
			     !!"J_ENTER" [],
			     !!"D_ENTER" []] || END

		CONTINUE IF "Event1" [] THEN
			STATE ["topstate.*.I.E.L.A.D","topstate.*.I.E.L.B.K",
			       "topstate.*.I.F.Q.*.H"]
			 OUT [!! "J_EXIT" [],
			      !! "K_ENTER" []] || END

		RESTART IF "Event1" [] THEN
			 STATE ["topstate.*.I.E.L.A.C","topstate.*.I.E.L.B.K",
				"topstate.*.I.F.R"]
			 OUT [!! "J_EXIT" [],
			      !! "K_ENTER" []] || END

		CONTINUE IF "Event2" [] THEN
			STATE ["topstate.*.I.E.L.A.D","topstate.*.I.E.L.B.J",
			       "topstate.*.I.F.Q.*.H"]
			OUT [!! "R_EXIT"  [],
			     !! "K_EXIT"  [],
			     !! "C_EXIT"  [],
			     !! "L_EXIT"  [],
			     !! "I_EXIT"  [],
			     !! "action"  [],
			     !! "I_ENTER" [],
			     !! "Q_ENTER" [],
			     !! "H_ENTER" [],
			     !! "L_ENTER" [],
			     !! "J_ENTER" [],
			     !! "D_ENTER" []] || END

		RESTART IF "Event3" [] THEN
			STATE ["topstate.*.I.E.L.A.C","topstate.*.I.E.L.B.J",
				"topstate.*.I.F.Q.*.G"]
			OUT [!! "R_EXIT"  [],
			     !! "Q_ENTER" [],
			     !! "G_ENTER" []] || END

		CONTINUE IF "Event2" [] THEN
			STATE ["topstate.*.I.E.L.A.D","topstate.*.I.E.L.B.J",
			       "topstate.*.I.F.Q.*.H"]
			OUT [!! "G_EXIT"  [],
			     !! "Q_EXIT"  [],
			     !! "J_EXIT"  [],
			     !! "C_EXIT"  [],
			     !! "L_EXIT"  [],
			     !! "I_EXIT"  [],
			     !! "action"  [],
			     !! "I_ENTER" [],
			     !! "Q_ENTER" [],
			     !! "H_ENTER" [],
			     !! "L_ENTER" [],
			     !! "J_ENTER" [],
			     !! "D_ENTER" []] || END

		CONTINUE END


	NEXT "test/run/trans12.vsp"

		INITIAL (["topstate.*.A.B.C","topstate.*.A.E.F"],[]) || END

		STEPS IF "event" [] THEN
			STATE ["topstate.*.A.B.D","topstate.*.A.E.G"]
			OUT   [!!"right" [], !! "left" []] || END
		CONTINUE END

	NEXT "test/run/trans13.vsp"

		INITIAL (["topstate.*.A.B.C","topstate.*.A.E.G.*.H", 
			 "topstate.*.A.J.K"],[]) || END

		STEPS IF "event" [] THEN
			STATE ["topstate.*.A.B.D","topstate.*.A.E.G.*.I",
			       "topstate.*.A.J.L"]
			OUT   [!!"right" [], !!"middle" [], !!"left" []] || END
		CONTINUE END

	NEXT "test/run/trans14.vsp"

		INITIAL (["topstate.*.S.*.A.C.C1", 
			  "topstate.*.S.*.A.B.B1"],
			 [!! "S_ENTER" [],
			  !! "A_ENTER" [],
			  !! "C1_ENTER" [],
			  !! "B1_ENTER" []]) || END
		STEPS IF "Event2" [] THEN
			STATE ["topstate.*.S.*.A.C.C1", "topstate.*.S.*.A.B.B2"]
			OUT   [!!"B1_EXIT" [],
			       !!"action1" [],
			       !!"B2_ENTER" []] || END
		CONTINUE IF "Event1" [] THEN
			STATE ["topstate.*.S.*.A.C.C2", "topstate.*.S.*.A.B.B1"]
			OUT   [!!"C1_EXIT" [],
			       !!"B2_EXIT" [],
			       !!"A_EXIT" [],
			       !!"S_EXIT" [],
			       !!"action1" [],
			       !!"S_ENTER" [],
			       !!"A_ENTER" [],
			       !!"C2_ENTER" [],
			       !!"B1_ENTER" []] || END

		CONTINUE END

	NEXT "test/run/trans15.vsp"

		INITIAL (["topstate.*.U.*.V.*.W"],
			[!! "U_ENTER" [],
			 !! "V_ENTER" [],			 
			 !! "W_ENTER" []]) || END

		STEPS IF "Event1" [] THEN
			STATE NO_CHANGE
			OUT [!! "W_EXIT" [],
			     !! "V_EXIT" [],         
			     !! "action1" [],
			     !! "V_ENTER" [],
			     !! "W_ENTER" []] || END

		CONTINUE IF "Event1" [] THEN
			STATE NO_CHANGE
			OUT [!! "W_EXIT" [],
			     !! "V_EXIT" [],         
			     !! "action1" [],
			     !! "V_ENTER" [],
			     !! "W_ENTER" []] || END

		CONTINUE END

	NEXT "test/run/signals01.vsp"

		INITIAL (["topstate.*.A.B.C","topstate.*.A.E.G"],
				[!!"C_ENTER" [],
				 !!"first" []]) || END
		STEPS END
	
	NEXT "test/run/signals02.vsp"

		INITIAL (["topstate.*.A.B.C.*.D", "topstate.*.A.E.H"],
				[!!"C_ENTER" [],
				 !!"D_ENTER" [],
				 !!"first"   [],
				 !!"second"  []]) || END
		STEPS END

	NEXT "test/run/signals03.vsp"

		INITIAL (["topstate.*.A.B.C.*.D", "topstate.*.A.E.I"],
				[!!"C_ENTER" [],
				 !!"D_ENTER" [],
				 !!"first"   [],
				 !!"second"  [],
				 !!"third"   []]) || END
		STEPS END

	NEXT "test/run/history01.vsp" INITIAL (["topstate.*.S.*.S1"],
					       [!!"action1" []]) || END
		STEPS IF "E" [] THEN STATE ["topstate.*.S.*.S2"]
				     OUT   [!!"action2" []] || END
		CONTINUE IF "E" [] THEN STATE ["topstate.*.S.*.S3"]
				   OUT   [!!"action3" []] || END
		CONTINUE IF "E" [] THEN STATE ["topstate.*.S.*.S1"]
				   OUT   [!!"action1" []] || END
		RESTART  IF "D" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE END

	NEXT "test/run/history02.vsp" INITIAL (["topstate.*.first.*.A"],[]) || END

		STEPS	 IF "Event2" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event1" [] THEN 
				STATE ["topstate.*.first.*.B"]
				OUT   [] || END
		CONTINUE IF "Event2" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event1" [] THEN 
				STATE ["topstate.*.first.*.C"]
				OUT   [] || END
		CONTINUE IF "Event2" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event3" [] THEN 
				STATE ["topstate.*.D"]
				OUT   [] || END
		CONTINUE IF "Event2" [] THEN STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event3" [] THEN 
				STATE ["topstate.*.first.*.C"]
				OUT   [] || END
		CONTINUE IF "Event1" [] THEN 
				STATE ["topstate.*.first.*.A"]
				OUT   [] || END
		CONTINUE IF "Event1" [] THEN 
				STATE ["topstate.*.first.*.B"]
				OUT   [] || END
		CONTINUE IF "Event3" [] THEN 
				STATE ["topstate.*.D"]
				OUT   [] || END
		CONTINUE IF "Event3" [] THEN 
				STATE ["topstate.*.first.*.B"]
				OUT   [] || END
		CONTINUE END

	NEXT "test/run/history03.vsp" INITIAL (["topstate.*.G.H.first.*.A",
						"topstate.*.G.I.E"],
					       [!!"G_ENTER" [],
						!!"E_ENTER" [],
						!!"first_ENTER" [],
						!!"A_ENTER" []]) || END
		STEPS IF "Event1" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.first.*.B"]
				OUT [!!"E_EXIT"  [],
				     !!"F_ENTER" [],
				     !!"A_EXIT"  [],
				     !!"B_ENTER" [] ] || END  
		CONTINUE IF "Event1" [] THEN
				STATE ["topstate.*.G.I.E",
				       "topstate.*.G.H.first.*.C"]
				OUT   [!!"F_EXIT"  [],
				       !!"E_ENTER" [],
				       !!"B_EXIT"  [],
				       !!"C_ENTER" []] || END

		CONTINUE IF "Event5" [] THEN
				STATE NO_CHANGE 
				OUT   [!!"E_EXIT"      [],
				       !!"C_EXIT"      [],
				       !!"first_EXIT"  [],
				       !!"G_EXIT"      [],
				       !!"action1"     [],
				       !!"G_ENTER"     [],
				       !!"E_ENTER"     [],
				       !!"first_ENTER" [],
				       !!"C_ENTER" []] || END

		(* next step only added so that we can use the case *)
		(* for C1 with its reinitialization bug             *)

		CONTINUE IF "INIT" [] THEN
				STATE ["topstate.*.G.I.E",
				       "topstate.*.G.H.first.*.A"]
				OUT   [!!"E_EXIT"  [],
				       !!"C_EXIT" [],
				       !!"first_EXIT"  [],
				       !!"G_EXIT" [],
				       !!"G_ENTER" [],
				       !!"E_ENTER" [],
				       !!"first_ENTER" [],
				       !!"A_ENTER" [],
				       !!"A_EXIT"  [],
				       !!"A_ENTER" []] || END

		CONTINUE IF "Event1" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.first.*.B"]
				OUT [!!"E_EXIT"  [],
				     !!"F_ENTER" [],
				     !!"A_EXIT"  [],
				     !!"B_ENTER" [] ] || END  
		CONTINUE IF "Event1" [] THEN
				STATE ["topstate.*.G.I.E",
				       "topstate.*.G.H.first.*.C"]
				OUT   [!!"F_EXIT"  [],
				       !!"E_ENTER" [],
				       !!"B_EXIT"  [],
				       !!"C_ENTER" []] || END

		CONTINUE IF "Event4" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.first.*.C"]
				OUT   [!!"E_EXIT"  [],
				       !!"C_EXIT"  [],
				       !!"first_EXIT" [],
				       !!"G_EXIT"  [],
				       !!"action2" [],
				       !!"G_ENTER" [],
				       !!"F_ENTER" [],
				       !!"first_ENTER" [],
				       !!"C_ENTER" []] || END
		CONTINUE END

	NEXT "test/run/history04.vsp" INITIAL (["topstate.*.G.H.first.*.A",
						"topstate.*.G.I.E"],
					       [!!"G_ENTER" [],
						!!"E_ENTER" [],
						!!"first_ENTER" [],
						!!"A_ENTER" []]) || END
		STEPS IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.D"]
				OUT [!!"E_EXIT"  [],
				     !!"F_ENTER" [],
				     !!"A_EXIT"  [],
				     !!"first_EXIT" [],
				     !!"D_ENTER" [] ] || END  
		CONTINUE IF "Event2" [] THEN
				STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.first.*.A"]
				OUT   [!!"D_EXIT"  [],
				       !!"first_ENTER" [],
				       !!"A_ENTER"     []] || END
		CONTINUE IF "Event2" [] THEN
				STATE ["topstate.*.J.K.L.M.N", 
				       "topstate.*.J.K.L.P.Q",
				       "topstate.*.J.Z.ZIET.*.AE",
				       "topstate.*.J.B1.C1"]
				OUT   [!!"F_EXIT"     [],
				       !!"A_EXIT"     [],
				       !!"first_EXIT" [],
				       !!"G_EXIT"     [],
				       !!"J_ENTER"    [],
				       !!"C1_ENTER"   [],
				       !!"ZIET_ENTER" [],
				       !!"AE_ENTER"   [],
				       !!"L_ENTER"    [],
				       !!"N_ENTER"    []] || END
		CONTINUE IF "Event1" [] THEN
				STATE ["topstate.*.J.B1.D1",
				       "topstate.*.J.Z.AA",
				       "topstate.*.J.K.L.M.O",
				       "topstate.*.J.K.L.P.R"]
				OUT   [!!"AA_ENTER" [],
				       !!"Q_EXIT"   [],
				       !!"R_ENTER"  []] || END
		CONTINUE IF "Event4" [] THEN
				STATE ["topstate.*.G.H.first.*.A",
				       "topstate.*.G.I.E"]
				OUT   [!!"O_EXIT" [],
				       !!"L_EXIT" [],
				       !!"J_EXIT" [],
				       !!"G_ENTER" [],
				       !!"E_ENTER" [],
				       !!"first_ENTER" [],
				       !!"A_ENTER" []] || END
		CONTINUE IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.D"]
				OUT [!!"E_EXIT"  [],
				     !!"F_ENTER" [],
				     !!"A_EXIT"  [],
				     !!"first_EXIT" [],
				     !!"D_ENTER" [] ] || END  
		CONTINUE IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.first.*.A"]
				OUT   [!!"D_EXIT"  [],
				       !!"first_ENTER" [],
				       !!"A_ENTER"     []] || END
		CONTINUE IF "Event2" [] THEN
				STATE ["topstate.*.J.K.L.M.O", 
				       "topstate.*.J.K.L.P.R",
				       "topstate.*.J.Z.ZIET.*.AE",
				       "topstate.*.J.B1.C1"]
				OUT   [!!"F_EXIT"     [],
				       !!"A_EXIT"     [],
				       !!"first_EXIT" [],
				       !!"G_EXIT"     [],
				       !!"J_ENTER"    [],
				       !!"C1_ENTER"   [],
				       !!"ZIET_ENTER" [],
				       !!"AE_ENTER"   [],
				       !!"L_ENTER"    [],
				       !!"R_ENTER"    []] || END
		CONTINUE END 
	
	NEXT "test/run/Lift.vsp" INITIAL (["Lift.*.LightFirstOff",
				     "Lift.*.LightGroundOff",  
				     "Lift.*.stopped",
				     "Lift.*.groundFloor", 
				     "Lift.*.opened" ], []) || END

		STEPS IF "E_FIRST_PRESSED" [] THEN		
			STATE ["Lift.*.LightFirstOn",
			       "Lift.*.LightGroundOff", 
			       "Lift.*.runningUp",
			       "Lift.*.Moving", 
			       "Lift.*.closed" ] 
			OUT   [!!"LightOnFirst" [],
			       !!"CloseDoor"    [],
			       !!"MotorUp"      [] ] || END
		CONTINUE IF "E_LIFT_ARRIVED" [] THEN
			STATE ["Lift.*.LightFirstOff",
			       "Lift.*.LightGroundOff", 
			       "Lift.*.stopped",
			       "Lift.*.firstFloor", 
			       "Lift.*.opened" ]
			OUT   [!!"StopMotor"     [],
			       !!"LightOffFirst" [],
			       !!"OpenDoor"      [] ] || END

		(* FIXME: lift test may be made much longer *)	
		CONTINUE END
		
	NEXT "test/run/peer.vsp" 
		INITIAL DONT_TEST || END
		STEPS END

		(* FIXME: some steps and initial could be made *)
	NEXT END

	(* FIXME: add climate, clockradio and may be more *)
	(* FIXME: sthg for do reactions *)
	(* FIXME: sthg with internal transitions *)


(* version of history04 for CF *)

val cfhistory04 = "test/run/history04.vsp" INITIAL (["topstate.*.G.H.first.*.A",
						"topstate.*.G.I.E"],
					       [!!"G_ENTER" [],
						!!"E_ENTER" [],
						!!"first_ENTER" [],
						!!"A_ENTER" []]) || END
		STEPS IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.D"]
				OUT [!!"E_EXIT"  [],
				     !!"F_ENTER" [],
				     !!"A_EXIT"  [],
				     !!"first_EXIT" [],
				     !!"D_ENTER" [] ] || END  
		CONTINUE IF "Event2" [] THEN
				STATE NO_CHANGE OUT [] || END
		CONTINUE IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.first.*.A"]
				OUT   [!!"D_EXIT"  [],
				       !!"first_ENTER" [],
				       !!"A_ENTER"     []] || END
		CONTINUE IF "Event2" [] THEN
				STATE ["topstate.*.J.K.L.M.N", 
				       "topstate.*.J.K.L.P.Q",
				       "topstate.*.J.Z.ZIET.*.AE",
				       "topstate.*.J.B1.C1"]
				OUT   [!!"A_EXIT"     [],
				       !!"F_EXIT"     [],
				       !!"first_EXIT" [],
				       !!"G_EXIT"     [],
				       !!"J_ENTER"    [],
				       !!"C1_ENTER"   [],
				       !!"ZIET_ENTER" [],
				       !!"AE_ENTER"   [],
				       !!"L_ENTER"    [],
				       !!"N_ENTER"    []] || END
		CONTINUE IF "Event1" [] THEN
				STATE ["topstate.*.J.B1.D1",
				       "topstate.*.J.Z.AA",
				       "topstate.*.J.K.L.M.O",
				       "topstate.*.J.K.L.P.R"]
				OUT   [!!"AA_ENTER" [],
				       !!"Q_EXIT"   [],
				       !!"R_ENTER"  []] || END
		CONTINUE IF "Event4" [] THEN
				STATE ["topstate.*.G.H.first.*.A",
				       "topstate.*.G.I.E"]
				OUT   [!!"O_EXIT" [],
				       !!"L_EXIT" [],
				       !!"J_EXIT" [],
				       !!"G_ENTER" [],
				       !!"E_ENTER" [],
				       !!"first_ENTER" [],
				       !!"A_ENTER" []] || END
		CONTINUE IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.D"]
				OUT [!!"E_EXIT"  [],
				     !!"F_ENTER" [],
				     !!"A_EXIT"  [],
				     !!"first_EXIT" [],
				     !!"D_ENTER" [] ] || END  
		CONTINUE IF "Event3" [] THEN
				STATE ["topstate.*.G.I.F",
				       "topstate.*.G.H.first.*.A"]
				OUT   [!!"D_EXIT"  [],
				       !!"first_ENTER" [],
				       !!"A_ENTER"     []] || END
		CONTINUE IF "Event2" [] THEN
				STATE ["topstate.*.J.K.L.M.O", 
				       "topstate.*.J.K.L.P.R",
				       "topstate.*.J.Z.ZIET.*.AE",
				       "topstate.*.J.B1.C1"]
				OUT   [!!"A_EXIT"     [],
				       !!"F_EXIT"     [],
				       !!"first_EXIT" [],
				       !!"G_EXIT"     [],
				       !!"J_ENTER"    [],
				       !!"C1_ENTER"   [],
				       !!"ZIET_ENTER" [],
				       !!"AE_ENTER"   [],
				       !!"L_ENTER"    [],
				       !!"R_ENTER"    []] || END
		CONTINUE END; 
	
