(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/testset-sig.sml,v
   Comment: Signature of test set definition (a single test set is normally
            implemented in a single test script)
   Release: scope-0-16_final

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   testset-sig.sml,v 1.1 2003/03/15 21:07:04 wasowski Exp 
*)

signature TEST_SET = sig

	val name : string

	type input
	type output

	val testcases : (string * input * (output -> bool)) list
	val run : string * input -> output

end

(*
   [name] is the name of the given set of tests, used for display 

   [input] is the type of inputs for tests. Inputs are passed to the test
   procedure.

   [output] is the type of outputs of tests. Outputs are produced by the test
   procedure and then their are evaluated for correctness using the function
   given in test cases.

   [testcases] is the set of cases to be executed

   [run name input] is the test procedure. It accepts the testcase name and input
   and produces the output.
*)
